/*
 * ColorChooser.java
 *
 * Created on 11. maj 2005, 13:20
 */

package drno.swingui.guiView;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionListener;

import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author  Leo
 */
public class ColorChooser extends javax.swing.JFrame {
    String selectedBackgroundElement = "";
	String selectedForegroundElement = "";
    /** Creates new form ColorChooser */
    public ColorChooser() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jColorChooser1 = new javax.swing.JColorChooser();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList2 = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
		
		getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
		jPanel1.setLayout(null);

        jButton2.setText("OK");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton2);
        jButton2.setBounds(300, 360, 80, 23);

        jPanel1.add(jColorChooser1);
        jColorChooser1.setBounds(190, 0, 409, 333);

        jButton1.setText("Annuller");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton1);
        jButton1.setBounds(400, 360, 80, 23);

        jButton3.setText("Anvend");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton3);
        jButton3.setBounds(500, 360, 80, 23);
		
        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Tabel", "Infomation", "Ansat", "Tidsreservation", "JCalendar","ProgressBar","Knapper","Label","Menu" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
		ListSelectionModel LSM1 = jList1.getSelectionModel();
        LSM1.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //Ignore extra messages.
                if (e.getValueIsAdjusting()) return;

                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                if (lsm.isSelectionEmpty()) {
					selectedBackgroundElement = "";
                    //System.out.println("No rows are selected.");
                }
                else {
					jList2.clearSelection();
                    selectedBackgroundElement = (String)jList1.getSelectedValue();
					//System.out.println(selectedBackgroundElement);
					//System.out.println(selectedForegroundElement);
                }
            }
        });
		jScrollPane1.setViewportView(jList1);

        jPanel1.add(jScrollPane1);
        jScrollPane1.setBounds(10, 40, 170, 120);

        jLabel1.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        jLabel1.setText("Baggrund:");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(10, 20, 110, 20);

        jList2.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Tabel", "Infomation", "Ansat", "Tidsreservation", "Knapper", "Menu", "JCalendar","Label","ProgressBar" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
		ListSelectionModel LSM2 = jList2.getSelectionModel();
        LSM2.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //Ignore extra messages.
                if (e.getValueIsAdjusting()) return;

                ListSelectionModel lsm = (ListSelectionModel)e.getSource();
                if (lsm.isSelectionEmpty()) {
					selectedForegroundElement = "";
                    //System.out.println("No rows are selected.");
                }
                else {
                    jList1.clearSelection();
					selectedForegroundElement = (String)jList2.getSelectedValue();
					//System.out.println(selectedBackgroundElement);
					//System.out.println(selectedForegroundElement);
                }
            }
        });
        jScrollPane2.setViewportView(jList2);

        jPanel1.add(jScrollPane2);
        jScrollPane2.setBounds(10, 190, 170, 140);

        jLabel2.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 11));
        jLabel2.setText("Text:");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(10, 170, 110, 20);

		getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 597, 410));

        pack();
        
        Dimension dim = getToolkit().getScreenSize();
        Rectangle rec = getBounds();
        int x = dim.width/2-rec.width/2;
        int y = dim.height/2-rec.height/2;
        setLocation(x,y);
    }//GEN-END:initComponents

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        //jTable1.setBackground(jColorChooser1.getColor());
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ColorChooser().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JColorChooser jColorChooser1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JList jList1;
    private javax.swing.JList jList2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables
	
	//ActionListners:
	public void setOKListener(ActionListener listener) {
		jButton2.addActionListener(listener);
	}
	public void setAnnullerListener(ActionListener listener) {
		jButton1.addActionListener(listener);
	}
	public void setAnvendListener(ActionListener listener) {
		jButton3.addActionListener(listener);
	}
    
	//get- set- Metoder til ColorChooser:
	public Color getChoosedColor(){
		return jColorChooser1.getColor();
	}
	public String getList1Element(){
		return selectedBackgroundElement;
	}
	public String getList2Element(){
		return selectedForegroundElement;
	}
	
}
